<?php
class TFunctions extends TDBoperations {

    /**
    * Rekurzivni funkce
    * (return string) - strom kategorii, tegy <option>
    * 
    * @param mixed $table - z jake tabulky
    * @param mixed $id_kategorie(1) - od ktere kategorie se ma zacit vypisovat
    * @param mixed $level - urcuje hloubku vnoreni, nenastavovat
    * @param mixed $result - nenastavovat
    */                       
    private
        function recurseKategorie($table, $id_kategorie, $selectId, $level=-1, $result=""){
            $sql= "SELECT id_kategorie, nazev 
                    FROM $table 
                    WHERE id_nad_kategorie = $id_kategorie
                    ORDER BY nazev";
            $queryResult= $this->Select($sql);
            $level++;   
            foreach($queryResult as $key => $value){
                if(count($queryResult)>0) $result= $this->recurseKategorie($table, $value['id_kategorie'], $selectId, $level, $result);
                $selectId==$value['id_kategorie'] ? $selected="selected=\"selected\"" : $selected="";
                $result= " <option class=\"lp$level\" $selected value=\"".$value['id_kategorie']."\">".$value['nazev']."</option>". $result;    
            }         
            return $result;
        }      
        
    public
    /**
    * zobrazi combobox s kategoriemi
    * return string - strom kategorii
    * 
    * @param mixed $table - z jake tabulky
    * @param mixed $id_kategorie(1) - od ktere kategorie se ma zacit vypisovat
    */
    function showKategorieInCombo($table, $id_kategorie, $selectId=0){
        $result= "<select name=\"id_kategorie\">";    
        $result.=  $this->recurseKategorie($table, $id_kategorie, $selectId);
        $result.= "</select>";
        return $result;
    }
    
    /**
    * vraci prni radek tabulky, nazvy sloupcu
    * <table><tr><td>sl1</td><td>sl2</td><td>...</td></tr>
    * 
    * @param $colsNames - array("sl1","sl2","...");
    * @param $oznac - true/false (zobrazi nazev oznac pro sloupec s checkobxy)
    */
    function showTableHead($colsNames, $oznac=true){
        $result= "<table>
                    <thead>
                        <tr>";
        foreach($colsNames as $value)
            $result.= "<td>$value</td>";
            
        if($oznac) $result.= "<td>Označ</td>";
        $result.= "</tr></thead>";
        return $result;
    }
    
    /**
    * zobrazi select s barvami
    * return string
    * 
    * @param $id - obleceni nebo produktu
    * @param $tabulka - nad jakou tabulkou provezt
    * @param $size - velikost selectu
    */    
    function showDostupnostBarvy($id=0, $tabulka, $size=4){
    //  vytvori pole dostupnych barev daneho obleceni
    $tabulka=="obleceni" ? $tab="obl_bar" : $tab="pro_bar";
    if(!$id==0){
        $query= "SELECT id_barvy FROM $tab WHERE id_$tabulka=$id";
        $resultQuery= $this->Select($query);
        $selectId= array();
        foreach($resultQuery as $key => $value)
            array_push($selectId, $value['id_barvy']);
    }
    $query= "SELECT id_barvy, barva FROM barvy ORDER BY barva";

    $resultQuery= $this->Select($query);
    $result= "
        <div class=\"dostBar\">
        <h1>Dostupnost barev</h1>
        <select name=\"barvy[]\" size=\"$size\" multiple=\"multiple\">
            <option value=\"---\">---</option>
    ";
    foreach($resultQuery as $key => $value){
        $idBarvy= $value['id_barvy'];
        $val= $value['barva'];
        $result.= "<option ";
        if(!$id==0) 
            if(in_array($idBarvy,$selectId)) $result.= "selected=\"selected\"";
        $result.= "value=\"$idBarvy\">$val</option>";
    }
    $result.= "</select></div>";
    return $result;
    }
    
    /**
    * zobrazi select s velikostmi
    * return string
    * 
    * @param $id - obleceni nebo produktu
    * @param $tabulka - nad jakou tabulkou provezt
    * @param $size - velikost selectu
    */
    function showDostupnostVelikost($id=0,$tabulka, $size=4){
        $tabulka=="obleceni" ? $tab="obl_vel" : $tab="pro_vel";   
        //  vytvori pole dostupnych velikosti daneho obleceni
        if(!$id==0){
            $query= "SELECT id_velikost FROM $tab WHERE id_$tabulka=$id";
            $resultQuery= $this->Select($query);
            $selectId= array();
            foreach($resultQuery as $key => $value)
                array_push($selectId, $value['id_velikost']);
        }
        //  naplni select vsemi velikostvmi a vybere odpovidajici
        $query= "SELECT id_velikost, velikost FROM velikost";
        $resultQuery= $this->Select($query);
        $result= "";
        $result.= "
            <div class=\"dostVel\">
            <h1>Dostupnost ve velikostech</h1>
            <select name=\"velikost[]\" size=\"$size\" multiple=\"multiple\">
                <option value=\"---\">---</option>
        ";
        foreach($resultQuery as $key => $value){
            $idVelikost= $value['id_velikost'];
            $val= $value['velikost'];
            $result.= "<option ";
            if(!$id==0) 
                if(in_array($idVelikost,$selectId)) $result.= "selected=\"selected\"";
            $result.= "value=\"$idVelikost\">$val</option>";
        }
        $result.= "</select></div>";
        return $result;
    }
    
    /**
    * nastavi odpovidajici hodnoty v propojovacich tabulkach
    * 
    * @param $values - pole id velikosti
    * @param $id
    * @param $table - obl_vel, obl_bar, pro_vel, pro_bar
    */
    function AddUpdateInSpoje($values, $id, $table){
        foreach($values as $value){
            $values= array();                                                
            array_push($values, $id);
            array_push($values, $value);
            switch($table){
                case "obl_vel":
                    $this->Insert("obl_vel", "id_obleceni, id_velikost", $values);
                break;
                
                case "obl_bar":
                    $this->Insert("obl_bar", "id_obleceni, id_barvy", $values);
                break;
                
                case "pro_vel":
                    $this->Insert("pro_vel", "id_produkty, id_velikost", $values);
                break;
                
                case "pro_bar":
                    $this->Insert("pro_bar", "id_produkty, id_barvy", $values);    
                break;            
            }
        }        
    }   
    
}
?>