<?php
include 'class/settings/info_firma.php';

class Tobjednavky extends TFunctions{
    private
    /**
    * vraci pole informaci o vybrane objednavce
    * 
    * @param mixed $selectId
    * @return mixed
    */
    function getObjednavkaInfo($selectId){
        $query="
            SELECT id_objednavky, id_uziv, dat_objednavky, dat_odeslani, dat_vyrizeni, cena_celkem, pozadavek, dodaci_adresa, dph
            FROM objednavky WHERE id_objednavky= $selectId
        ";
        $objInfo= $this->Select($query);
        return $objInfo[0];
    }        
    
    public    
    function getDatObjednavky($selectId){
        $query= "SELECT date_format(dat_objednavky, '%Y-%m-%d') as datum FROM objednavky WHERE id_objednavky = $selectId";
        $result= $this->Select($query);
        return $result[0]['datum'];
    }
    
    /**
    * zobrazi tabulku objednavek
    * return string
    * 
    * @param mixed $priznak
    */
    function showObjednavky($priznak=""){
        $podminka="";
        if($priznak=="odeslane") $podminka= "WHERE dat_odeslani IS NOT NULL";
        if($priznak=="vyrizene") $podminka= "WHERE dat_vyrizeni IS NOT NULL";  
        if($priznak=="neodeslane") $podminka= "WHERE dat_odeslani IS NULL";
        $query= "SELECT id_objednavky, dat_objednavky, dat_odeslani, dat_vyrizeni, cena_celkem FROM objednavky $podminka";
        $objednavka= $this->Select($query);
        $prepinac=2;
        $result= "
            <div class=\"tabulka\">
                <form action=\"admin.php?menu=objednavky\" method=\"post\">
                ".$this->showTableHead(array("Id", "Dat. objednání", "Dat. odeslání", "Dat. vyřízení", "Celková cena"))."
                <tfoot>
                    <tr><td colspan=\"11\"><input class=\"submit\" type=\"submit\" name=\"odeslat\" value=\"Odebrat vybrané\" /></td></tr>
                </tfoot> 
                <tbody>
        ";
        foreach($objednavka as $key => $value){
            $prepinac==1 ? $prepinac=2 : $prepinac=1;
            $href="\"admin.php?menu=objednavky&amp;selectId=".$value['id_objednavky']."\"";
            $result.="
                <tr class=\"row$prepinac\">
                    <td class=\"wc50\"><a href=$href>".$value['id_objednavky']."</a></td>
                    <td class=\"wc100\">".$value['dat_objednavky']."</td>
                    <td class=\"wc100\">".$value['dat_odeslani']."</td>
                    <td class=\"wc100\">".$value['dat_vyrizeni']."</td>
                    <td class=\"wc100\">".$value['cena_celkem'].",-</td>
                    <td class=\"wc50\"><input type=\"checkbox\" name=\"".$value['id_objednavky']."\" /></td>                    
                </tr>
            ";
        }
        $result.="</tbody></table></form></div>";
        return $result;
    }
    
    function showObjednavkaInfo($objInfo){
        $iF= new TinfoFirma();
        $infoFirma= $iF->getInfo();
        if($objInfo['dodaci_adresa']=="")
        {
            $query="SELECT jmeno, prijmeni, mesto, ulice, psc FROM uziv WHERE id_uziv=".$objInfo['id_uziv'];
            $uzivAdr= $this->Select($query);
            $uzivAdr= $uzivAdr[0];
        }else{
            $p = xml_parser_create();
            xml_parse_into_struct($p, $objInfo['dodaci_adresa'], $adr, $index);
            xml_parser_free($p);  
            $uzivAdr= array("jmeno" => $adr[2]['value'], "prijmeni" => "", "ulice" => $adr[4]['value'],
                            "mesto" => $adr[6]['value'], "psc" => $adr[8]['value']);
        }
        $result= "
            <div class=\"objInfo\">
                <div class=\"firma\">
                    <label>Název firmy:</label><p>".$infoFirma['nazev']."</p>
                    <label>IČO:</label><p>".$infoFirma['ico']."</p>
                    <label>Ulice:</label><p>".$infoFirma['ulice']."</p>
                    <label>Město:</label><p>".$infoFirma['psc']." ".$infoFirma['mesto']."</p>
                </div>
        ";
        $result.=
            "<div class=\"adresa\">
                <label>Jméno:</label><p>".$uzivAdr['jmeno']." ".$uzivAdr['prijmeni']."</p>
                <label>Ulice:</label><p>".$uzivAdr['ulice']."</p>
                <label>Město:</label><p>".$uzivAdr['mesto']."</p>
                <label>PSČ:</label><p>".$uzivAdr['psc']."</p>
            </div>
        ";               
        $result.="
            <div class=\"datumy\">
                <label>Datum objednávky: </label><p>".$objInfo['dat_objednavky']."</p><br />
                <form action=\"admin.php?menu=objednavky&amp;selectId=".$objInfo['id_objednavky']."\" method=\"post\">
                <fieldset>
                <label>Datum odeslání: </label>
                    <input type=\"text\" name=\"datOdeslani\" value=\"".$objInfo['dat_odeslani']."\" maxlength=\"10\" />
                <label>Datum vyřízení: </label>
                    <input type=\"text\" name=\"datVyrizeni\" value=\"".$objInfo['dat_vyrizeni']."\" maxlength=\"10\" />
                <input class=\"submit\" type=\"submit\" name=\"odeslat\" value=\"Ulož datumy\" />
                </fieldset>
                </form>
            </div>
            </div>            
        ";
    return $result;
    }
    
    function showObjednavkaDetail($selectId){
        $query="SELECT id_produkty, nazev_produktu, nazev_obleceni, velikost, barva, pocet, cena, sleva
                    FROM pro_obj WHERE id_objednavky= $selectId";
        $obj= $this->Select($query);
        $result="
            <div class=\"tabulka\">
            <table class=\"objTable\">
                <thead>
                    <tr>
                        <td class=\"wc30\">Id</td>
                        <td class=\"wc200\">Název produktu</td>
                        <td class=\"wc250\">Název oblečení</td>
                        <td class=\"wc50\">Velikost</td>
                        <td class=\"wc200\">Barva</td>
                        <td class=\"wc50\">Počet</td>
                        <td class=\"wc50\">Bez DPH</td>
                        <td class=\"wc50\">DPH</td>
                        <td class=\"wc50\">s DPH</td>
                        <td class=\"wc50\">Sleva</td>
                    </tr>
                </thead>
                <tbody>
        ";
        $prepinac=2;
        foreach($obj as $key => $values){
            $prepinac==1 ? $prepinac=2 : $prepinac=1;
            $result.="
                <tr class=\"row$prepinac\">
                    <td class=\"wc30\">".$values['id_produkty']."</td>
                    <td>".$values['nazev_produktu']."</td>
                    <td>".$values['nazev_obleceni']."</td>
                    <td class=\"wc50\">".$values['velikost']."</td>
                    <td>".$values['barva']."</td>
                    <td class=\"wc50\">".$values['pocet']."</td>
                    <td class=\"wc50\">". round($values['cena'] / 1.19, 1) .",-</td>
                    <td class=\"wc50\">". round($values['cena'] - $values['cena'] / 1.19, 1) .",-</td>  
                    <td class=\"wc50\">".$values['cena'].",-</td>  
                    <td class=\"wc50\">".$values['sleva']."</td>
                </tr>
            ";
        }
        $result.="</tbody></table></div><div class=\"corrector\"></div>";
        return $result;
    }
    
    function showObjednavkaBottom($pozadavek){
        $result="
            <div class=\"objednavkaBottom\">
                <h1>Dotaz zákazníka</h1>
                <div class=\"pozadavek\">
                    $pozadavek
                </div>
            </div>
        ";
        return $result;
    }
    
    /**
    * zobrazi vybranou kompletni objednavku jako fakturu
    * 
    * @param mixed $selectId
    */
    function showObjednavka($selectId){
        $objInfo= $this->getObjednavkaInfo($selectId);
        $result= $this->showObjednavkaInfo($objInfo);
        $result.= $this->showObjednavkaDetail($selectId);
        $result.= $this->showObjednavkaBottom($objInfo['pozadavek']);
        return $result;
    }
    
    function saveDatum($idObjednavky, $data){
        $datum= array("dat_odeslani"=> $data['datOdeslani'], "dat_vyrizeni"=> $data['datVyrizeni']);
        $this->Update("objednavky", $datum, "id_objednavky=$idObjednavky");
    }
}
?>
