<?php
class TProdukt extends TFunctions {
    private
    function getProdukty($sort="nazev"){
        $result= $this->Select("
            SELECT id_produkty, nazev, hodnoceni, dat_vlozeni, cena, poc_prodanych, novinka, akce, publikovano, jazyk 
                FROM produkty ORDER BY $sort"
        );
        return $result;
    }
    /**
    *   vytvori pole vybranych moznos pro dany produkt nad dannou tabulkou (barvy, velikost)
    * 
    * @param mixed $tabulka
    * @param mixed $idProduktu
    */
    function makeVyber($tabulka, $idProduktu){
        $tabulka=="barvy" ? $tab= "pro_bar" : $tab= "pro_vel";
        $query= "SELECT id_$tabulka as id FROM $tab WHERE id_produkty = $idProduktu";
        $resultQuery= $this->Select($query);
        $selectId= array();
        foreach($resultQuery as $key => $value)
            array_push($selectId, $value['id']);
        return $selectId;
    }

    function showDostupnostBarvy($idProduktu, $idObleceni, $size=15){
    if(!$idProduktu==0){
        $selectId= $this->makeVyber("barvy", $idProduktu);
    }

    $query= "SELECT obl_bar.id_barvy, barva FROM obl_bar, barvy 
                WHERE obl_bar.id_obleceni = $idObleceni
                AND obl_bar.id_barvy= barvy.id_barvy";
    $resultQuery= $this->Select($query);   
    
    $vybrano=0;
    $options="";
    foreach($resultQuery as $key => $value){
        $idBarvy= $value['id_barvy'];
        $val= $value['barva'];
        $options.= "<option ";
        if(!$idProduktu==0) 
            if(in_array($idBarvy,$selectId)){
                $options.= "selected=\"selected\"";
                $vybrano++;
            }
        $options.= "value=\"$idBarvy\">$val</option>";
    }
    
    $vybrano==0 ? $select= "selected=\"selected\"" : $select= "";
    $result= "
        <div class=\"dostBar\">
        <h1>Dostupnost barev</h1>
        <select name=\"barvy[]\" size=\"$size\" multiple=\"multiple\">
            <option value=\"---\" $select>---</option>
    ";    
    
    $result.= $options . "</select></div>";
    return $result;
    }  
    
    function showDostupnostVelikost($idProduktu, $idObleceni, $size=6){
    if(!$idProduktu==0){
        $selectId= $this->makeVyber("velikost", $idProduktu);
    }

    $query= "SELECT obl_vel.id_velikost, velikost FROM obl_vel, velikost 
                WHERE obl_vel.id_obleceni = $idObleceni
                AND obl_vel.id_velikost= velikost.id_velikost";
   
    $resultQuery= $this->Select($query);
    $vybrano=0;
    $options="";
    foreach($resultQuery as $key => $value){
        $idVelikost= $value['id_velikost'];
        $val= $value['velikost'];
        $options.= "<option ";
        if(!$idProduktu==0) 
            if(in_array($idVelikost,$selectId)){
                $options.= "selected=\"selected\"";
                $vybrano++;
            } 
        $options.= "value=\"$idVelikost\">$val</option>";
    }
    $result= "
        <div class=\"dostVel\">
        <h1>Dostupnost ve velikostech</h1>
        <select name=\"velikost[]\" size=\"$size\" multiple=\"multiple\">
            <option value=\"---\">---</option>
    ";
    $result.= $options . "</select></div>";
    return $result;
    }         
    
    public
    
    /**
    * zobrazi tabulku s prehledem obleceni
    * return string
    * 
    * @param $data - vysledek dotazu select
    */    
    function showTable($sort="nazev"){
        $data= $this->getProdukty($sort);
        $href= "admin.php?menu=produkty&amp;tabs=prehled";
        $result= "<form action=\"$href\" method=\"post\">";
        $colsNames= array("Id","Název","Hod.","Dat. vlož.","Cena","prodej/ks", "jazyk", "N", "A", "P");
        $prepinac=2;
        $result.= $this->showTableHead($colsNames)."
            <tfoot>
                <tr><td colspan=\"11\"><input class=\"submit\" type=\"submit\" name=\"odeslat\" value=\"Odebrat vybrané\" /></td></tr>
            </tfoot> 
            <tbody>";
        foreach($data as $key => $value){
            $prepinac==1 ? $prepinac=2 : $prepinac=1;
            $href= "admin.php?menu=produkty&amp;tabs=pridat&amp;selectId=". $value['id_produkty'];
            $value['novinka']==1 ? $novinka= "checked=\"checked\"" : $novinka= "";
            $value['akce']==1 ? $akce= "checked=\"checked\"" : $akce="";
            $value['publikovano']==1 ? $publikovano= "checked=\"checked\"" : $publikovano="";
            $result.= "<tr class=\"row$prepinac\">
                        <td class=\"wc50\">". $value['id_produkty']. "</td>
                        <td class=\"w250\"><a href=\"$href\">".$value['nazev']."</a></td>
                        <td class=\"w50\">". $value['hodnoceni']. "</td>
                        <td class=\"wc100\">". $value['dat_vlozeni']. "</td>                           
                        <td class=\"wc50\">". $value['cena']. ",-</td>                           
                        <td class=\"w50\">". $value['poc_prodanych']. "</td>                           
                        <td class=\"wc50\">". $value['jazyk']. "</td>                           
                        <td class=\"wc50\"><input type=\"checkbox\" disabled=\"disabled\" name=\"novinka\" $novinka /></td>
                        <td class=\"wc50\"><input type=\"checkbox\" disabled=\"disabled\" name=\"akce\" $akce /></td>
                        <td class=\"wc50\"><input type=\"checkbox\" disabled=\"disabled\" name=\"publikovano\" $publikovano /></td>
                        <td class=\"wc50\"><input type=\"checkbox\" name=\"".$value['id_produkty']."\" /></td>
                       </tr>";
        }
        
        $result.= "</tbody></table></form>";   
        return $result;
    }
    
    /**
    * zobrazi combobox s uzivateli
    * return string
    */    
    function showComboboxUziv($selectId=0){
        $result="";
        $query= "SELECT id_uziv, email, jmeno, prijmeni FROM uziv";
        $resultQuery= $this->Select($query);
        $result.= "<select name=\"id_uziv\">";
        foreach($resultQuery as $key => $value){
            $selectId==$value['id_uziv'] ? $selected="selected=\"selected\"" : $selected="";
            $result.= "<option $selected value=\"". $value['id_uziv']."\">";
            $result.= $value['email'];
            $result.= "</option>";
        }
        $result.= "</select>";
        return $result;
    }
       
    /**
    * zobrazi combobox s oblecenim
    * return string
    */    
    function showComboboxObleceni($selectId=0){
        $result="";
        $query= "SELECT id_obleceni, nazev FROM obleceni";
        $resultQuery= $this->Select($query);
        $result.= "<select name=\"id_obleceni\">";
        foreach($resultQuery as $key => $value){
            $selectId==$value['id_obleceni'] ? $selected="selected=\"selected\"" : $selected="";
            $result.= "<option $selected value=\"". $value['id_obleceni']."\">";
            $result.= $value['nazev'];
            $result.= "</option>";
        }
        $result.= "</select>";
        return $result;
    }       
        
    /**
    * zobrazi formular pro pridani nebo editaci
    * return string
    * 
    * @param $values - pole s pripadnymi hodnotami pro update
    */
    function showAddUpdateForm($values=""){
        $result= "";
        $action= "admin.php?menu=produkty&amp;tabs=prehled";
        if(!$values['id_produkty']=="") $action.= "&amp;selectId=".$values['id_produkty'];
        $values['novinka']==1 ? $novinka= "checked=\"checked\"" : $novinka= "";
        $values['akce']==1 ? $akce= "checked=\"checked\"" : $akce="";
        $values['publikovano']==1 ? $publikovano= "checked=\"checked\"" : $publikovano=""; 
        $values['id_kategorie']=="" ? $idKategorie=0 : $idKategorie=$values['id_kategorie'];
        $values['id_uziv']=="" ? $idUziv=0 : $idUziv=$values['id_uziv'];
        $values['id_obleceni']=="" ? $idObleceni=1 : $idObleceni=$values['id_obleceni'];  
        $result.= "
        <div class=\"addForm\">
            <form action=\"$action\" method=\"post\">
                <div class=\"addUpdate\">            
                    <label>Název</label>
                        <div><input class=\"w150\"type=\"text\" name=\"nazev\" value=\"".$values['nazev']."\" /></div>
                    <label>Oblečení</label>
                        <div>". $this->showComboboxObleceni($idObleceni) ."</div>                    
                    <label>Uživatel</label>
                        <div>". $this->showComboboxUziv($idUziv) ."</div>
                    <label>Kategorie</label>
                        <div>". $this->showKategorieInCombo("kategorie", 1, $idKategorie) ."</div>                    
                    <label>Popis</label>
                        <div><textarea rows=\"5\" cols=\"25\" name=\"popis\">".htmlspecialchars($values['popis'])."</textarea></div>
                    <label>Cena</label>
                        <div><input class=\"w50\"type=\"text\" name=\"cena\" value=\"".$values['cena']."\" /></div>
                    <label>Limit</label>
                        <div><input class=\"w50\"type=\"text\" name=\"limitovano\" value=\"".$values['limitovano']."\" /></div>
                    <label>Prodáno</label>
                        <div><input class=\"w50\"type=\"text\" name=\"poc_prodanych\" value=\"".$values['poc_prodanych']."\" /></div>
                    <label>Sleva</label>
                        <div><input class=\"w50\"type=\"text\" name=\"sleva\" value=\"".$values['sleva']."\" /></div>
                    <label>Seo</label>
                        <div><input class=\"w150\"type=\"text\" name=\"seo\" value=\"".$values['seo']."\" /></div>
                    <label>Jazyk</label>
                        <div><input class=\"w50\" type=\"text\" name=\"jazyk\" value=\"".$values['jazyk']."\" /></div>
                    <label>Novinka</label>
                        <div><input type=\"checkbox\" name=\"novinka\" $novinka /></div>
                    <label>Akce</label>
                        <div><input type=\"checkbox\" name=\"akce\" $akce /></div>
                    <label>Publikovano</label>
                        <div><input type=\"checkbox\" name=\"publikovano\" $publikovano /></div>
                </div>                     
        ";
        $result.= $this->showDostupnostBarvy($values['id_produkty'], $idObleceni, 10);
        $result.= $this->showDostupnostVelikost($values['id_produkty'], $idObleceni, 6);
        $result.= "
                <fieldset><input class=\"submit\" type=\"submit\" name=\"odeslat\" value=\"Uložit\" /></fieldset>   
            </form>
        </div>
        ";   
        $result.= "<div class=\"addForm\">";
        $result.= $this->showPictureForm("Nahraj", $values['id_produkty']);
        $result.= $this->showPictureForm("Nahraj detail", $values['id_produkty']);
        $result.= "</div>";
        return $result;
    }        
    
    /**
    * zobrazi formular pro vkladani obrazku
    * 
    * @param mixed $submitName - value tlacitka submit
    */
    function showPictureForm($submitName="Nahraj", $idImg){
        $submitName=="Nahraj" ? $nazev= "Nahrát obrázek" : $nazev= "Nahrát detail obrázku";
        $result = "
            <div class=\"loadPicture\">
            <h1>$nazev</h1>
            <form action=\"".htmlspecialchars("admin.php?menu=produkty&tabs=pridat&selectId=$idImg")."\" enctype=\"multipart/form-data\" method=\"post\">
                <fieldset>
                    <label>Cesta</label><input type=\"file\" name=\"file\" />
                </fieldset>
                <fieldset>
                    <input type=\"submit\" name=\"loadPicture\" value=\"$submitName\" />
                </fieldset>
            </form>
            </div>
        ";
        return $result;
    }   
    
    function imgPathToDb($idProdukt, $source, $detail=0){
        $pathInfo= pathinfo($source['name']);
        $values= array($idProdukt, $pathInfo['filename'], $detail);
        $query= $this->Insert("obrazky", "id_produkty, cesta, detail", $values);
    }
    
    /**
    * vytvori kopie puvodniho obrazku ve trech rozlisenich
    * (big-600x800, normal-300x400, thumb-150x200)
    * 
    * @param mixed $source
    */
    function copyProductImg($source, $detail=0){
        $pathInfo= pathinfo($source['name']);
        $dest= "img/produkty/";
        
        
        if($imgSource = imagecreatefromjpeg($source['tmp_name'])){
            list($width, $height) = getimagesize($source['tmp_name']);
            $newwidth = 300;       
            $newheight = 400;
            $img = imagecreatetruecolor($newwidth, $newheight);
            imagecopyresampled($img, $imgSource, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
            imagejpeg($img, $dest . $pathInfo['filename'] . "Normal." . $pathInfo['extension'], 100);        
            
            $newwidth = 150;
            $newheight = 200;
            $img = imagecreatetruecolor($newwidth, $newheight);
            imagecopyresampled($img, $imgSource, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
            imagejpeg($img, $dest . $pathInfo['filename'] . "Thumb." . $pathInfo['extension'], 100);     
            
            if($detail==1){ return true; } // pokud se jedna o detail ($detail == 1) zbivajici cast kodu se neprovede            
            
            $newwidth = 600;
            $newheight = 800;
            $img = imagecreatetruecolor($newwidth, $newheight);
            imagecopyresampled($img, $imgSource, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
            imagejpeg($img, $dest . $pathInfo['filename'] . "Big." . $pathInfo['extension'], 100);      
                        
            return true;
        }else{
            return false;
        }
        
    }
   
    function showProduktImg($idProdukt, $mode="Thumb.jpg", $detail=0){
        $query= "SELECT id_obrazky, cesta, detail, hlavni FROM obrazky WHERE id_produkty=$idProdukt AND detail=$detail";
        $cesty= $this->Select($query);
        if($detail==0){
            $nazev= "Obrázky";
            $class= "obrazky";
        }else{
            $nazev= "Detaily";
            $class= "detaily";
        } 
        $result="
            <div class=\"obrazky\">
                <h1>$nazev</h1>
        ";
        if(count($cesty)>0){
            $result.= "
                <form action=\"admin.php?menu=produkty&amp;tabs=pridat&amp;selectId=$idProdukt\" method=\"post\">
                <fieldset><input type=\"submit\" name=\"saveAtribut\" value=\"Uložit\" /></fieldset>
            ";
            foreach($cesty as $key => $value){
                if($value['hlavni']==1) {
                    $checked= "checked=\"checked\"";
                    $result.= "<input type=\"hidden\" name=\"oldIdImg\" value=\"". $value['id_obrazky']. "\" />";
                } else
                    $checked= "";
                $href= htmlspecialchars("
                    admin.php?menu=produkty&tabs=pridat&selectId=$idProdukt&cesta=". $value['cesta'] ."&detail=". $value['detail']
                );
                $result.= "
                    <div>
                        <a href=\"$href\" class=\"zrusit\"></a>
                        <div class=\"atribut\">
                            <label>H</label><input type=\"radio\" name=\"hlavni\" value=\"". $value['id_obrazky'] ."\" $checked />
                        </div>
                        <img src=\"./img/produkty/".$value['cesta']."$mode\" alt=\"obrázek produktu\" />
                    </div>
                ";
            }
            $result.="</form>";
        }
        $result.= "</div>";
        return $result;
    }
    
    function setHlavniImg($idObrazky, $oldIdImg=0){
        if($oldIdImg!=NULL){
            $set= array("hlavni" => 0);
            $this->Update("obrazky", $set, "id_obrazky = $oldIdImg");
        }        
        $set= array("hlavni" => 1);
        $this->Update("obrazky", $set, "id_obrazky = $idObrazky");
    }
    
    function delImg($cesta, $detail = 0){
        $this->Delete("obrazky", "cesta = '$cesta'");
        unlink("./img/produkty/$cesta"."Thumb.jpg");
        unlink("./img/produkty/$cesta"."Normal.jpg");
        if($detail==0)
            unlink("./img/produkty/$cesta"."Big.jpg");
    }
    
    function xmlExport(){
        $date= date("d. m. Y");
        $xml_output  = "<?xml version=\"1.0\"?>\n"; 
        $xml_output.= "
            <katalog_produktu>
                \t<datum>$date</datum>";
                
        $query= "SELECT id_produkty, nazev, hodnoceni, dat_vlozeni, cena, poc_prodanych FROM produkty";
        $rows= $this->Select($query);
        foreach($rows as $key => $row){
            $xml_output.= "<produkt>";
            foreach($row as $col => $value){
                $xml_output.= "\t\t<$col>".htmlspecialchars($value)."</$col>\n";
            }
            $xml_output.= "</produkt>";
        }
        
        $xml_output.= "
            </katalog_produktu>";
        $filename= "test.xml";
        $file= fopen($filename, "w");
        fwrite($file, $xml_output);
        return $xml_output; 
    }
}     
?>
