<?php
class TnavrhyShop extends TDBoperations{

    private
    function getInputFile($number){
        $result="
            <div>
                <label>Obrázek č.$number</label>
                <input type=\"file\" name=\"file$number\" accept=\"image/jpeg\" />
            </div>
        ";
        return $result;
    }
    
    function showHodnoceni($soucasneHodnoceni, $pocHodnoceni){
        $result= "
            <form action=\"". $_SERVER['REQUEST_URI'] ."\" method=\"post\">
              <ul class=\"hodnoceniHvezdicky\" title=\"Hodnocení produktu(1-5 hvězdiček), čím víc hvězdiček tím líp.\">
                <li><input class=\"hvezda1\" type=\"submit\" name=\"hodnoceni\" value=\"1\" /></li>
                <li><input class=\"hvezda2\" type=\"submit\" name=\"hodnoceni\" value=\"2\" /></li>
                <li><input class=\"hvezda3\" type=\"submit\" name=\"hodnoceni\" value=\"3\" /></li>
                <li><input class=\"hvezda4\" type=\"submit\" name=\"hodnoceni\" value=\"4\" /></li>
                <li><input class=\"hvezda5\" type=\"submit\" name=\"hodnoceni\" value=\"5\" /></li>
              </ul>
            <div>
                <span title=\"Aktuální hodnocení varianty vybraného návrhu, čím víc hvězdiček tím líp.\">$soucasneHodnoceni</span>
                <span class=\"pocHodnDetail\" title=\"Kolikrát bylo honoceno.\">$pocHodnoceni</span>
            </div>
            </form>

        ";
        return $result;        
    } 

    /**
    * vrati odkazy kategorii nad dannym produktem
    *    
    * @param mixed $id_kategorie
    * @param mixed $oddelenec - znaky ktere oddeluji jednotlive kategorie napr.: "->"
    */
    function showKategorieInNavrh($id_kategorie, $oddelenec){
        $query= "SELECT id_nad_kategorie, nazev, seo FROM kategorie_navrhy WHERE id_kategorie=$id_kategorie";
        $kategorie= $this->Select($query);    
        $result= "<a href=\"/".$kategorie[0]['seo'].".htm\">".$kategorie[0]['nazev']."</a>";
        if($kategorie[0]['id_nad_kategorie']>1){  
            $result= $this->showKategorieInNavrh($kategorie[0]['id_nad_kategorie'], $oddelenec). $oddelenec . $result;
        }
        return $result;
    }
    
    public
    
    function getNavrhyTitle($idNavrhu){
        $query= "SELECT nazev FROM navrhy WHERE id_navrhy = $idNavrhu";
        $produkt= $this->Select($query);
        return $produkt[0]['nazev'];
    }    
    
    function getKategorieTitle($idKategorie, $oddelenec){
        $query= "SELECT id_nad_kategorie, nazev FROM kategorie_navrhy WHERE id_kategorie=$idKategorie";
        $kategorie= $this->Select($query);    
        $result= $kategorie[0]['nazev'];
        if($kategorie[0]['id_nad_kategorie']>1)  
            $result= $this->getKategorieTitle($kategorie[0]['id_nad_kategorie'], $oddelenec). $oddelenec . $result;
        return $result;    
    }
    
    /**
    * vraci pole radku produktu obsazenych ve vsech kategoriich v dane kategorii
    * zakladni info pro nahledy
    * rekurzivni metoda
    * 
    * @param mixed $kategorie
    * @param mixed $priznak=""  - filtruje produkty akce a novnky ("A", "N")
    * @return array
    */
    function getNavrhyInKategorie($idKategorie, $priznak=""){
        $filtr="";
        if(!$priznak=="")
            $filtr= ($priznak=="N") ? " AND novinka=1" : "";
        
        $query= "SELECT navrhy.id_navrhy, navrhy.nazev, id_uziv, varianty.id_varianty, hodnoceni, poc_hodnoceni, 
                        kategorie_navrhy.seo as seo_kategorie, navrhy.seo as seo_navrhy
                    FROM navrhy, varianty, kategorie_navrhy
                    WHERE navrhy.id_navrhy = varianty.id_navrhy
                    AND navrhy.id_kategorie = kategorie_navrhy.id_kategorie
                    AND navrhy.id_kategorie = $idKategorie
                    AND varianty.publikovano = 1
                    AND varianty.hlavni = 1                    
                    $filtr";
        $navrhy= $this->Select($query);
        
        $query= "SELECT id_kategorie FROM kategorie_navrhy WHERE id_nad_kategorie=$idKategorie AND publikovano = 1";
        $kategorie= $this->Select($query);
        if(count($kategorie)>0){
            foreach($kategorie as $key => $value)
                $navrhy= array_merge($navrhy, $this->getNavrhyInKategorie($value['id_kategorie'], $priznak));
        }
        
        return $navrhy;
    }    
    
    function getNavrhyUzivatele($idUziv){
        $query= "SELECT navrhy.id_navrhy, navrhy.nazev, id_uziv, varianty.id_varianty, hodnoceni, poc_hodnoceni, 
                        kategorie_navrhy.seo as seo_kategorie, navrhy.seo as seo_navrhy
                    FROM navrhy, varianty, kategorie_navrhy
                    WHERE navrhy.id_navrhy = varianty.id_navrhy
                    AND navrhy.id_kategorie = kategorie_navrhy.id_kategorie
                    AND navrhy.id_uziv = $idUziv
                    AND varianty.publikovano = 1
                    AND varianty.hlavni = 1";
        $navrhy= $this->Select($query);
        return $navrhy;
    }    
    
    function utf2ascii($text){
        $result = Str_Replace(
                        Array("á","č","ď","é","ě","í","ľ","ň","ó","ř","š","ť","ú","ů","ý","ž","Á","Č","Ď","É","Ě","Í","Ľ","Ň","Ó","Ř","Š","Ť","Ú","Ů","Ý","Ž") ,
                        Array("a","c","d","e","e","i","l","n","o","r","s","t","u","u","y","z","A","C","D","E","E","I","L","N","O","R","S","T","U","U","Y","Z") ,
                        $text);
        $result = Str_Replace(Array(" ", "_"), "-", $result); //nahradí mezery a podtržítka pomlčkami
        $result = Str_Replace(Array("(",")",".","!",",","\"","'"), "", $result); //odstraní ().!,"'
        $result = StrToLower($result); //velká písmena nahradí malými.
        return $result;
    }
    
    function checkNazevInDB($nazev){
        $nazev= mysql_escape_string($nazev);
        $query= "SELECT nazev FROM navrhy WHERE nazev = '$nazev'";
        $result= $this->Select($query);
        if(count($result)>0)
            return "Tento název je již v databázi uložen, zkus pojmenovat svůj návrh jinak.";
        else 
            return "";
    }
    
    function checkKrok1($post){
        $message= "";
        if($post['nazev']== "" || $post['popis']== ""){
            $message.= "Svůj návrh musíš pojmenovat a popsat!<br />";
            return $message;
        }
        
        return $this->checkNazevInDB($post['nazev']);    
    }
    
    function copyProductImg($source, $userId){
        $pathInfo= pathinfo($source['name']);
        if(strtolower($pathInfo['extension']) != "jpg")
            return "Vložen nesprávný formát obrázku!";
            
        
        $dest= "img/navrhy/$userId";
        if(!file_exists($dest)) {
            mkdir($dest);
            mkdir($dest."/tmp");
        }
        $dest.= "/tmp";
        
        $rozliseni= getimagesize($source['tmp_name']);
        
        if($rozliseni[0]!=800 && $rozliseni[1]!=800) return "Obrázek vkládán ve špatném rozlišení, nutno 800x800px!";
        
        move_uploaded_file($source['tmp_name'], $dest."/".$source['name']);
    }
    
    function showKategorieMenu($id_kategorie, $selectId, $level=-1, $result=""){
        $sql= "SELECT id_kategorie, nazev, publikovano, seo 
                FROM kategorie_navrhy 
                WHERE id_nad_kategorie=$id_kategorie
                AND publikovano = 1
                ORDER BY nazev";
        $queryResult= $this->Select($sql);
        $level++;   
        foreach($queryResult as $key => $value){
            $pocProduktu= $this->countRecords("navrhy", "WHERE publikovano=1 and id_kategorie=".$value['id_kategorie']);
            $pocProduktu= ($pocProduktu==0) ? '' : "($pocProduktu)";
            $selectId==$value['id_kategorie'] ? $selected="class=\"menuSelected\"" : $selected="";
            if(count($queryResult)>0) $result= $this->showKategorieMenu($value['id_kategorie'], $selectId, $level, $result);
            $result= "
                <div $selected>
                    <a class=\"lp$level\" href=\"/navrhy/".$value['seo'].".htm\">".$value['nazev']."
                    </a><span>$pocProduktu</span>
                </div>". $result;    
        }         
        return $result;
    }
    
    function showUzivMoznosti(){
        $result="
            <div class=\"lMenu\">
                <h1>Možnosti</h1>
                    <div class=\"uzivMenu\">
                        <a rel=\"nofollow\" href=\"/navrhy/pridat-navrh-krok1.htm\">Přidat návrh</a>
                        <a rel=\"nofollow\" href=\"/navrhy/editovat-navrh-krok1.htm\">Editovat návrh</a>
                    </div>
            </div>
        ";
        return $result;
    }
    
    function showAddForm($id_uziv, $popis){
        $iNames= array("nazev", "popis");
        $message= array("chyba1", "chyba2");
        $result= "    
            <form action=\"/navrhy/pridat-navrh-krok23.htm\" method=\"post\" id=\"addForm\" name=\"addForm\">
                <fieldset>
                    <label for=\"nazev\">Název</label>
                    <input class=\"w200\" id=\"nazev\" name=\"nazev\" type=\"text\" size=\"20\" />
                </fieldset>
                <fieldset>
                    <label for=\"popis\">Popis</label>
                    <textarea id=\"popis\" name=\"popis\" style=\"width:100%\" rows=\"\" cols=\"\"></textarea>
                </fieldset>
                <fieldset><input onclick=\"checkFormInput(addForm);\" class=\"dalsi\" type=\"button\" name=\"odeslat\" value=\"Další\" /></fieldset>
            </form>                                                                                   
        ";
        return $result;
    }
    
    function showAddImgForm($pocObrazku){
        $result = "
            <div class=\"navrhForm\">
                <div class=\"loadPicture\">
                <form action=\"". $_SERVER['REQUEST_URI'] ."\" enctype=\"multipart/form-data\" method=\"post\" id=\"addForm\">";
                    for($i=1; $i<=$pocObrazku; $i++)
                        $result.= $this->getInputFile($i);
        $result.= "
                    <input type=\"submit\" name=\"loadPicture\" value=\"Nahrát obrázky\" />        
                </form>
                </div>
            </div>
        ";
        return $result;    
    }
    
    function showEditNavrhImgForm($idNavrhu, $pocVariant){
        $query= "SELECT nazev FROM navrhy WHERE id_navrhy = $idNavrhu";
        $resultQuery= $this->Select($query);
        $result= "
            <h1>Přidání nových variant k návrhu: ". $resultQuery[0]['nazev'] ."</h1>
        ";
        $result.= $this->showAddImgForm($pocVariant);
        return $result;
    }
    
    function showVariantyUziv($idNavrhu){
        $query= "SELECT id_varianty FROM varianty WHERE id_navrhy = $idNavrhu";
        $varianty= $this->Select($query);
        $cesta= $this->getCesty($idNavrhu);
        $cesta= $cesta['cesta'];
        $result= "<form action=\"". $_SERVER['REQUEST_URI'] ."\" method=\"post\">";
        $requestUri= preg_replace('/(.*-p[0-9]+).*/', '$1', $_SERVER['REQUEST_URI']);
        foreach($varianty as $key => $value){
            $href= $requestUri ."-v". $value['id_varianty'] .".htm";
            $result.= "
                <div>
                    <div class=\"oznac\">
                        <label>D</label><input type=\"checkbox\" name=\"v[]\" value=\"". $value['id_varianty'] ."\" />
                    </div>
                    <img src=\"/$cesta/". $value['id_varianty'] ."Thumb.jpg\" alt=\"Náhled varianty\" />
                </div>
            ";
        }
        $result.= "
                <input class=\"odstranit\" type=\"submit\" name=\"odstranit\" value=\"Odstranit vybrané\" />
            </form>";
        return $result;
    }
    
    function delVarianta($variantaId){
        $query= "
            SELECT id_varianty, seo, id_uziv FROM varianty, navrhy
                WHERE   id_varianty = $variantaId
                AND     varianty.id_navrhy = navrhy.id_navrhy
        ";
        $result= $this->Select($query);
        $result= $result[0];
        unlink("img/navrhy/".$result['id_uziv']."/".$result['seo']."/".$result['id_varianty'].".jpg");
        unlink("img/navrhy/".$result['id_uziv']."/".$result['seo']."/".$result['id_varianty']."Thumb.jpg");
        unlink("img/navrhy/".$result['id_uziv']."/".$result['seo']."/".$result['id_varianty']."BigThumb.jpg");
        $this->Delete("varianty", "id_varianty = $variantaId");        
    }
    
    /**
    * kontrola spravneho uploadu souboruu na server
    * return pole korektne uploadovanych souboruu
    * 
    * @param mixed $files
    */
    function checkFiles($files){
        $result= array();
        for($i=1; $i<=count($files); $i++) {
            if($files["file$i"]['error'] == 0) array_push($result, $files["file$i"]);
        }
        return $result;
    }
    /**
    * kontrola velikosti rozliseni
    * 
    * @param mixed $files
    */
    function kontrolaObrazku($files){
        $message= "";
        for($i=0; $i<count($files); $i++){
            if($files[$i]['error'] == 0){
                $pathInfo= pathinfo($files[$i]['name']);
                if(strtolower($pathInfo['extension']) != "jpg")
                    $message.= "Obrázek č.$i vkládán v nesprávném formátu!<br />";
                $rozliseni= getimagesize($files[$i]['tmp_name']);
                if($rozliseni[0]!=800 && $rozliseni[1]!=800) 
                    $message.= "Obrázek č.$i vkládán ve špatném rozlišení, nutno 800x800px!<br />";
            }
        }
        return $message;
    }
    
    function makeTmpImg($files, $userId){
        $dest= "img/navrhy/$userId";
        if(!file_exists($dest)) {
            mkdir($dest);
            mkdir($dest."/tmp");
        }
        $dest.= "/tmp";      
                                          
        for($i=0; $i<count($files); $i++){
            $fileInfo= pathinfo($files[$i]['tmp_name']);
            move_uploaded_file($files[$i]['tmp_name'], $dest ."/". $fileInfo['filename'] .".jpg");    
        }
    }
    
    function showPrehled($files, $userId){
        $dest= "img/navrhy/$userId/tmp";    
        $result="";  
        for($i=0; $i<count($files); $i++){
            $fileInfo= pathinfo($files[$i]['tmp_name']);
            $result.="
                <div>
                    <img src=\"/$dest/". $fileInfo['filename'] .".jpg\" />
                </div>
            ";
        }
        return $result;
    }
    
    function saveNavrh($info, $userId){
        $info['nazev']= mysql_escape_string($info['nazev']);
        $info['popis']= mysql_escape_string($info['popis']);
        
        $values= array($userId, 1, $info['nazev'], $info['popis'], 1, 0);
        $this->Insert("navrhy", "id_uziv, id_kategorie, nazev, popis, novinka, publikovano", $values);
        $idNavrhu= $this->getLastId("navrhy");
        $seo= $this->utf2ascii($info['nazev']) ."-p". $idNavrhu;
        $this->Update("navrhy", array("seo" => $seo), "id_navrhy = $idNavrhu");
        
        return $idNavrhu;
    }
     
    function saveNavrhImg($idNavrhu, $files){
        $cesty= $this->getCesty($idNavrhu);
        $src= $cesty['tmp'];
        $dest= $cesty['cesta'];
        if(!file_exists($dest)) mkdir($dest);
        for($i=0; $i<count($files); $i++){
            $values= array($idNavrhu, 0, 0);
            $this->Insert("varianty", "id_navrhy, publikovano, hlavni", $values);
            $idVarianty= $this->getLastId("varianty");
            
            $fileInfo= pathinfo($files[$i]['tmp_name']);
            if($imgSource = imagecreatefromjpeg("$src/". $fileInfo['filename'] .".jpg")){
                list($width, $height) = getimagesize("$src/". $fileInfo['filename'] .".jpg");
                $img = imagecreatetruecolor(150, 150);
                imagecopyresampled($img, $imgSource, 0, 0, 0, 0, 150, 150, $width, $height);
                imagejpeg($img, $dest ."/$idVarianty"."Thumb.jpg", 100);
                
                $img = imagecreatetruecolor(300, 300);
                imagecopyresampled($img, $imgSource, 0, 0, 0, 0, 300, 300, $width, $height);
                imagejpeg($img, $dest ."/$idVarianty"."BigThumb.jpg", 100);
                rename("$src/". $fileInfo['filename'] .".jpg", $dest ."/$idVarianty.jpg");
            }
        }
    }
 
    function leftInfo($krok){
        switch($krok){
            case 1:
                $result= "
                    <h1>Krok 1</h1>
                    <h2>Název/Popis</h2>
                    <p>Pojmenuj tvůj nový návrh a snaž se ho trochu popsat.</p>
                ";
            break;
            case 2:
                $result= "
                    <h1>Krok 2</h1>
                    <h2>Obrázky</h2>
                    <p>
                        Obrázky je nutné vkládat v rozlišení <b>800x800px</b> a ve formátu <b>jpeg</b>. Obrázek č.1 bude
                        automaticky nastaven jako hlavní. Náhledy vložených variant budou zobrazeny v dalším kroce.
                    </p>
                ";
            break;
            case 3:
                $result= "
                    <h1>Krok 3</h1>
                    <h2>Přehled</h2>
                    <p>
                        Přehled vložených variant. Pokud se ti nelíbí některá varianta, dej zpět a vlož soubory znovu.
                        Nezapomínej, že první vložená varianta bude zobrazena v náhledu mezi návrhy ostatních uživatelů!
                    </p>
                ";
            break;  
            case 4:
                $result= "
                    <h1>Krok 4</h1>
                    <h2>Odesláno</h2>
                    <p>
                        Úspěšně jste vložili svůj návrh. Nyní bude schválen správcem webu a poté vložen do patřičné kategorie,
                        kde bude hodnocen. O vložení do sekce návrhy budete informováni.
                    </p>
                ";
            break;
            case 11:
                $result= "
                    <h1>Krok 1</h1>
                    <h2>Výběr návrhu</h2>
                    <p>
                        Vyber návrh, ke kterému chceš přidat novou variantu nebo odstranit starou variantu.
                    </p>
                ";
            break;
            case 12:
                $result= "
                    <h1>Krok 2</h1>
                    <h2>Varianty</h2>
                    <p>
                        Zde můžeš přidat nebo odstranit variantu.
                    </p>
                ";
            break;
                                    
        }
        return $result;
    }
    
    function showNahledyNavrhy($navrhy, $limitOd= 0, $limitPocet=9, $priznak="", $uziv=0){
        $result="";
        
        for($i=$limitOd; $i<$limitOd+$limitPocet; $i++){
            foreach($navrhy[$i] as $key => $val)
                $value[$key]= $val;
              
            $cesta= "/img/navrhy/". $value['id_uziv'] ."/". $value['id_navrhy'] ."/". $value['id_varianty'];
            
            if($uziv == 0)
                $href= "navrhy/". $value['seo_kategorie'] ."/". $value['seo_navrhy'] ."-v". $value['id_varianty'] .".htm";
            else
                $href= "navrhy/editovat-navrh-krok2-n". $value['id_navrhy'] .".htm";
            
            $imageDetail= $cesta .".jpg";
            $idNavrhu= $value['id_navrhy'];
            $result.="
                    <div class=\"nahledNavrhu\">
                        <div id=\"img$idNavrhu\" class=\"zoom\" style=\"display: none;\">
                            <img src=\"$imageDetail\" alt=\"Návrh: ". $value['nazev'] ."\" />
                            <div class=\"ramecek\"></div>
                        </div>                    
                        <h1>". $value['nazev'] ."</h1>
                        <a href=\"/$href\" onmouseover=\"show('img$idNavrhu')\" onmouseout=\"hide('img$idNavrhu')\">
                            <img src=\"". $cesta ."Thumb.jpg\" alt=\"Náhled návrhu ". $value['nazev'] ."\" />
                        </a>
                        <div class=\"navrhInfo\">
                            <div>
                                <span title=\"Počet komentářů\">K-". $this->getPocKomentaru($value['id_varianty']) ."</span>
                                <span title=\"Počet variant\">V-". $this->getPocVariant($value['id_navrhy'], "A") ."</span>
                            </div>                        
                            <div class=\"hodnoceni\">
                                <span title=\"Hodnocení\">".$value['hodnoceni']."</span>
                                <span class=\"pocHodnoceni\" title=\"Počet hodnocení\">".$value['poc_hodnoceni']."</span>
                            </div>                 
                        </div>
                    </div>
            ";    
        }
        return $result;
    }

    function getPocVariant($idNavrhy, $publikovano=""){
        if($publikovano == "A") $publikovano= " AND publikovano = 1";
        if($publikovano == "N") $publikovano= " AND publikovano = 0";
        $query= "SELECT count(*) as pocet FROM varianty WHERE id_navrhy = $idNavrhy $publikovano";
        $result= $this->Select($query);
        return $result[0]['pocet'];
    }    
    function getPocKomentaru($idVarianty){
        $query= "SELECT count(*) as pocet FROM dis_var WHERE id_varianty = $idVarianty";
        $result= $this->Select($query);
        return $result[0]['pocet'];
    }
    function getCesty($idNavrhu){
        $query= "SELECT id_uziv, id_navrhy FROM navrhy WHERE id_navrhy = $idNavrhu";
        $resultQuery= $this->Select($query);
        if(count($resultQuery)==0)
            return "Vybraný návrh byl buď přesunut do obchodu a je již k prodeji nebo byl odstraněn z databáze.";
        else{        
            $resultQuery= $resultQuery[0];
            $cesty=  array( "tmp" => "img/navrhy/". $resultQuery['id_uziv'] ."/tmp",
                            "cesta" => "img/navrhy/". $resultQuery['id_uziv'] ."/". $resultQuery['id_navrhy']);
            return $cesty;
        }
    }
    
    function showNavrh($idNavrhu, $idVarianta=0){
        $hlavni= ($idVarianta == 0) ? "AND hlavni = 1" : "AND varianty.id_varianty = $idVarianta";
        $query= "
            SELECT  nazev, popis, jmeno, prijmeni, id_varianty, navrhy.id_uziv, seo, hodnoceni, poc_hodnoceni, 
                    id_kategorie, date_format(datum_publikovani, '%d. %m. %Y') as datum
                FROM navrhy, uziv, varianty
                WHERE   navrhy.id_uziv = uziv.id_uziv
                AND     navrhy.id_navrhy = varianty.id_navrhy
                AND     navrhy.id_navrhy = $idNavrhu
                $hlavni
        ";
        $navrh= $this->Select($query);
        if(count($navrh)==0)
            return "";
        else{
            $navrh= $navrh[0];
            
            $cesta= "/img/navrhy/". $navrh['id_uziv'] ."/$idNavrhu/". $navrh['id_varianty'] .".jpg";
                        
            $result="
                <div class=\"panelKategorie\">
                    <div class=\"question\" title=\"při najetí myší na požadované místo obdržíte nápovědu\"></div>
                    ".$this->showKategorieInNavrh($navrh['id_kategorie'], " - ")."
                </div>            
                <div>
                    <h1>". $navrh['nazev'] ."</h1>
                    ". $navrh['popis'] ."
                </div>
                <div>
                    <div class=\"variantaInfo\">
                        <span style=\"float:left;\">Vloženo: ". $navrh['datum'] ."</span>
                        <span style=\"float:right;\">Autor: ". $navrh['jmeno'] ." ". $navrh['prijmeni'] ."</span>
                        <div class=\"corrector\"></div>
                    </div>
                </div>
                    <div>
                        <img src=\"$cesta\" alt=\"Návrh: ". $navrh['nazev'] ."\" />
                    </div>
                <div class=\"hodnoceni\">
                    ".$this->showHodnoceni($navrh['hodnoceni'], $navrh['poc_hodnoceni'])."
                </div>";
            return $result;
        }
    }
    
    function showVarianty($idNavrhu, $selecteId=0){
        $query= "
            SELECT id_varianty, hodnoceni, poc_hodnoceni FROM varianty 
                WHERE id_navrhy = $idNavrhu AND publikovano = 1
        ";
        $varianty= $this->Select($query);
        $cesta= $this->getCesty($idNavrhu);
        $result= "";
        if(count($varianty)>1){
            $requestUri= preg_replace('/(.*-p[0-9]+).*/', '$1', $_SERVER['REQUEST_URI']);
            foreach($varianty as $key => $value){
                $pocKomentaru= $this->countRecords("dis_var", "WHERE id_varianty = ". $value['id_varianty']);
                $selected= ($selecteId == $value['id_varianty']) ? "class=\"selectedVarianta\"" : "";
                $href= $requestUri ."-v". $value['id_varianty'] .".htm";
                $result.= "
                    <div class=\"nahledNavrhu\">
                        <a href=\"$href\">
                            <img $selected src=\"/". $cesta['cesta'] ."/". $value['id_varianty'] ."Thumb.jpg\" alt=\"Náhled varianty\" />
                        </a>
                        <div class=\"navrhInfo\">
                            <div>
                                <span title=\"Počet komentářů\">K-". $this->getPocKomentaru($value['id_varianty']) ."</span>
                            </div>                        
                            <div class=\"hodnoceni\">
                                <span title=\"Hodnocení\">".$value['hodnoceni']."</span>
                                <span class=\"pocHodnoceni\" title=\"Počet hodnocení\">".$value['poc_hodnoceni']."</span>
                            </div>                 
                        </div>
                    </div>
                ";
            }
        }
        return $result;
    }
    
    function hodnotUziv($idUziv, $idVarianty, $znamka){
        $query= "SELECT COUNT(znamka)as pocet FROM hod_var WHERE id_uziv=$idUziv AND id_varianty = $idVarianty";
        $result= $this->Select($query);
        if($result[0]['pocet']==0){
            $values= array($idVarianty, $idUziv, $znamka);
            $this->Insert("hod_var", "id_varianty, id_uziv, znamka", $values);
            return true;
        }else{
            return false;
        }
    }
    
    function hodnotHost($IP, $idVarianty, $znamka){
        $query= "SELECT COUNT(znamka)as pocet FROM hod_var_host WHERE IP='$IP' AND id_varianty = $idVarianty";
        $result= $this->Select($query);
        if($result[0]['pocet']==0){
            $values= array($idVarianty, $IP, $znamka);
            $this->Insert("hod_var_host", "id_varianty, IP, znamka", $values);
            return true;
        }else{
            return false;
        }
    }
}
?>
