<?php
class TshopFunctions extends TDBoperations{
    private
        function pevnaMezera($pocet){
            $result="";
            for($i=0; $i<$pocet; $i++){
                $result.= "&nbsp;";
            }
            return $result;
        }
    
        /**
        * vytvori strom odkazu vsech kategorie
        * 
        * @param mixed $id_kategorie - od ktere kategorie bude strom tvoren
        * @param mixed $selectId - oznaci vzbranou kategorie(class=menuSelected)
        * @param mixed $level
        * @param mixed $result
        */
        function recurseKategorie($id_kategorie, $selectId, $level=-1, $result=""){
            $sql= "SELECT id_kategorie, nazev, publikovano, seo 
                    FROM kategorie 
                    WHERE id_nad_kategorie=$id_kategorie
                    AND publikovano = 1
                    ORDER BY nazev";
            $queryResult= $this->Select($sql);
            $level++;   
            foreach($queryResult as $key => $value){
                $pocProduktu= $this->countRecords("produkty", "WHERE publikovano=1 and id_kategorie=".$value['id_kategorie']);
                $pocProduktu= ($pocProduktu==0) ? '' : "($pocProduktu)";
                $selectId==$value['id_kategorie'] ? $selected="class=\"menuSelected\"" : $selected="";
                if(count($queryResult)>0) $result= $this->recurseKategorie($value['id_kategorie'], $selectId, $level, $result);
                $result= "
                    <div $selected>
                        <a class=\"lp$level\" href=\"/obchod/".$value['seo'].".htm\">".$value['nazev']."</a>
                        <span>$pocProduktu</span>
                    </div>". $result;    
            }         
            return $result;
        } 
        /**
        * vytvori select(combobox) s barvami pro dany produkt
        * 
        * @param mixed $idProdukty                
        */
        function showBarva($idProdukty){
            //  vytvori pole dostupnych velikosti daneho obleceni
            $query= "SELECT barvy.id_barvy, barvy.barva 
                        FROM barvy, pro_bar
                        WHERE pro_bar.id_produkty=$idProdukty
                        AND pro_bar.id_barvy=barvy.id_barvy";
            $resultQuery= $this->Select($query);
            
            $result= "<select class=\"barva\" name=\"barva\" id=\"barva\">";
            foreach($resultQuery as $key => $value)
                    $result.= "<option value=\"".$value['id_barvy']."\">".$value['barva']."</option>";
            $result.= "</select>";
            
            return $result;        
        }    
        /**
        * vytvori select(combobox) s velikostmi pro dany produkt
        * 
        * @param mixed $idProdukty
        */
        function showVelikost($idProdukty){
            //  vytvori pole dostupnych velikosti daneho obleceni
            $query= "SELECT velikost.id_velikost, velikost.velikost, sirka, vyska 
                        FROM velikost, pro_vel, obleceni, obl_vel, produkty 
                        WHERE pro_vel.id_produkty = $idProdukty
                        AND produkty.id_produkty = $idProdukty
                        AND velikost.id_velikost = pro_vel.id_velikost
                        AND produkty.id_obleceni = obleceni.id_obleceni
                        AND obleceni.id_obleceni = obl_vel.id_obleceni
                        AND obl_vel.id_velikost = velikost.id_velikost";
            $resultQuery= $this->Select($query);
            
            $result= "<select class=\"w120\" name=\"velikost\" id=\"velikost\">";
            foreach($resultQuery as $key => $value)
                    $result.= "
                        <option value=\"".$value['id_velikost']."\">"
                        .$value['velikost']. $this->pevnaMezera(4-strlen($value['velikost'])) . $value['sirka'] ." x ". $value['vyska']."
                        </option>";
            $result.= "</select>";         
            
            return $result;        
        }
    /**
    * vrati odkazy kategorii nad dannym produktem
    *    
    * @param mixed $id_kategorie
    * @param mixed $oddelenec - znaky ktere oddeluji jednotlive kategorie napr.: "->"
    */
    function showKategorieInProdukt($id_kategorie, $oddelenec){
        $query= "SELECT id_nad_kategorie, nazev, seo FROM kategorie WHERE id_kategorie=$id_kategorie";
        $kategorie= $this->Select($query);    
        $result= "<a href=\"/".$kategorie[0]['seo'].".htm\">".$kategorie[0]['nazev']."</a>";
        if($kategorie[0]['id_nad_kategorie']>1){  
            $result= $this->showKategorieInProdukt($kategorie[0]['id_nad_kategorie'], $oddelenec). $oddelenec . $result;
        }
        return $result;
    }
    /**
    * vraci pole obsahujici vsehny informace urciteho produktu vcetne vsech propojenych tabulek
    * 
    * @param mixed $id_produkty
    * @return array
    */
    function GetProdukt($id_produkty){
        $result= "";
        $query= "SELECT produkty.id_kategorie, produkty.id_obleceni, produkty.id_uziv, produkty.nazev, produkty.popis, 
                        produkty.cena, dat_vlozeni, limitovano, poc_prodanych, hodnoceni, poc_hodnoceni, novinka, akce,
                        sleva, mater, gramaz, obleceni.nazev as nazev_obl, obleceni.popis as popis_obl
                    FROM produkty, obleceni 
                    WHERE id_produkty=$id_produkty
                    AND produkty.id_obleceni=obleceni.id_obleceni                    
                    ";
        $produkt= $this-> Select($query);
        $produkt= $produkt[0];
        return $produkt;
    }

    function getImg($idProdukt, $mode="Normal.JPG", $detail, $hlavni){
        $query= "SELECT cesta FROM obrazky WHERE id_produkty=$idProdukt AND detail=$detail AND hlavni = $hlavni";
        $cesty= $this->Select($query);
        if($pocet=count($cesty)>=1){
            $result= "<img src=\"/img/produkty/".$cesty[0]['cesta']."$mode\" alt=\"Náhled produktu\" />";
        }else{
            $result= "<img src=\"/img/produkty/testImg$mode\" alt=\"testovaci obrazek\"/>";
        }
        return $result;
    }      
    
    function getImgPath($idProdukt, $detail){
        $query= "SELECT cesta FROM obrazky WHERE id_produkty=$idProdukt AND detail=$detail";
        $result= $this->Select($query);
        return $result[0]['cesta'];
    }   

    function showHodnoceni($soucasneHodnoceni, $pocHodnoceni){
        $result= "
            <form action=\"". $_SERVER['REQUEST_URI'] ."\" method=\"post\">
              <ul class=\"hodnoceniHvezdicky\" title=\"Hodnocení produktu(1-5 hvězdiček), čím víc hvězdiček tím líp.\">
                <li><input class=\"hvezda1\" type=\"submit\" name=\"hodnoceni\" value=\"1\" /></li>
                <li><input class=\"hvezda2\" type=\"submit\" name=\"hodnoceni\" value=\"2\" /></li>
                <li><input class=\"hvezda3\" type=\"submit\" name=\"hodnoceni\" value=\"3\" /></li>
                <li><input class=\"hvezda4\" type=\"submit\" name=\"hodnoceni\" value=\"4\" /></li>
                <li><input class=\"hvezda5\" type=\"submit\" name=\"hodnoceni\" value=\"5\" /></li>
              </ul>
            <div>
                <span title=\"Aktuální hodnocení produktu, čím víc hvězdiček tím líp.\">$soucasneHodnoceni</span>
                <span class=\"pocHodnDetail\" title=\"Kolikrát bylo honoceno.\">$pocHodnoceni</span>
            </div>
            </form>
        ";
        return $result;        
    }    
//---------------------------------- PUBLIC ------------------------------------------------    
  public    
    function getProduktTitle($idPruduktu){
        $query= "SELECT nazev FROM produkty WHERE id_produkty = $idPruduktu";
        $produkt= $this->Select($query);
        return $produkt[0]['nazev'];
    }
    
    function getKategorieTitle($idKategorie, $oddelenec){
        $query= "SELECT id_nad_kategorie, nazev FROM kategorie WHERE id_kategorie=$idKategorie";
        $kategorie= $this->Select($query);    
        $result= $kategorie[0]['nazev'];
        if($kategorie[0]['id_nad_kategorie']>1)  
            $result= $this->getKategorieTitle($kategorie[0]['id_nad_kategorie'], $oddelenec). $oddelenec . $result;
        return $result;    
    }

    function kontrolaEmail($email){
        if (ereg("^[_a-zA-Z0-9\.\-]+@[_a-zA-Z0-9\.\-]+\.[a-zA-Z]{2,4}$", $email) 
                && !ereg("\.{2,}", $email) && !ereg("_{2,}", $email) && !ereg("-{2,}", $email) )
            return true;
        else return false;
    }
    
    function kontrolaPass($pass){
        if(ereg("^[a-zA-Z0-9]*$", $pass))
            return true;
        else return false;
    }
    
    function showMenu($selectId=0){
        $result= "
            <div class=\"lMenu\">
                <h1>Kategorie</h1>
                <div class=\"kategorie\">
                    ".$this->recurseKategorie(1, $selectId)."
                </div>
            </div>
            ";        
        return $result;
    }
    
    function showPanelKategorie($idKategorie, $priznak=""){
        switch($priznak){
            case "N": $panelKategorie= "Novinky"; break;
            case "A": $panelKategorie= "Aktuality"; break;
            default : $panelKategorie= $this->showKategorieInProdukt($idKategorie, " - ");
        }
        $result="<div class=\"panelKategorie\">$panelKategorie</div>";
        return $result;
    }
    
    /**
    * vraci pole radku produktu obsazenych ve vsech kategoriich v dane kategorii
    * zakladni info pro nahledy
    * rekurzivni metoda
    * 
    * @param mixed $kategorie
    * @param mixed $priznak=""  - filtruje produkty akce a novnky ("A", "N")
    * @return array
    */
    function getProduktyInKategorie($kategorie, $priznak=""){
        $filtr="";
        if(!$priznak==""){
            if($priznak=="A") $filtr.= " AND akce=1";
            if($priznak=="N") $filtr.= " AND novinka=1";
        }
        $query= "SELECT id_produkty, produkty.id_kategorie, produkty.nazev, hodnoceni, poc_hodnoceni, cena, 
                        produkty.publikovano, novinka, akce, concat(kategorie.seo, '/', produkty.seo) as seo
                    FROM produkty, kategorie 
                    WHERE produkty.id_kategorie=$kategorie 
                    AND produkty.id_kategorie= kategorie.id_kategorie
                    AND produkty.publikovano=1 $filtr";
        $produkty= $this->Select($query);
        $query= "SELECT id_kategorie FROM kategorie WHERE id_nad_kategorie=$kategorie AND publikovano = 1";
        $kategorie= $this->Select($query);
        if(count($kategorie)>0){
            foreach($kategorie as $key => $value)
                $produkty= array_merge($produkty, $this->getProduktyInKategorie($value['id_kategorie'], $priznak));
        }
        return $produkty;
    }
    
    function showNahledyProdukty($produkty, $limitOd= 0, $limitPocet=9, $priznak=""){
        $result="";

        for($i=$limitOd; $i<$limitOd+$limitPocet; $i++){
            foreach($produkty[$i] as $key => $val)
                $value[$key]= $val;

            if($value['hodnoceni']=="") $value['hodnoceni']="_N_";
            $novinka=   ($value['novinka']==1)  ?  "<div class=\"novinka\"></div>"  : "";
            $akce=      ($value['akce']==1)     ?  "<div class=\"akce\"></div>"     : "";
            $image= $this->getImg($value['id_produkty'],"Thumb.jpg", 0, 1);
            $imageDetail= $this->getImg($value['id_produkty'],"Normal.jpg", 1, 1);
            $idProduktu= $value['id_produkty'];
                 
            $result.= "<div class=\"nahledy\">
                        <a class=\"nazev\" href=\"/obchod/".$value['seo'].".htm\">".$value['nazev']."</a>
                        $novinka
                        $akce
                        <div class=\"lupaPos\" onmouseover=\"show('img$idProduktu')\" onmouseout=\"hide('img$idProduktu')\">
                            <div class=\"lupaBack\"></div>
                            <div class=\"lupaImg\"></div>
                        </div>
                        <div id=\"img$idProduktu\" class=\"zoom\" style=\"display: none;\">
                            $imageDetail
                            <div></div>
                        </div>
                        <a href=\"/obchod/".$value['seo'].".htm\">$image</a>
                        <div class=\"hodnoceni\"><span title=\"Hodnocení\">".$value['hodnoceni']."</span>
                            <span class=\"pocHodnoceni\" title=\"Počet hodnocení\">".$value['poc_hodnoceni']."</span></div>
                        <div class=\"cena\">".$value['cena'].",- Kč</div>
                       </div>";
        }
        $result.= "<div class=\"corrector\"></div>";
        return $result;           
    }
    
    function showProdukt($idProdukty, $idKategorie, $message=""){
        $produkt= $this->GetProdukt($idProdukty);
        $gramaz= ($produkt['gramaz']==0) ? "" : "<label>Gramáž:</label><p>". $produkt['gramaz']." g/m2</p>";
        $disp= ($message=="") ? "dispNo" : "dispYes";
        $result= "
            <div class=\"printIcon\" title=\"tisk\" onclick=\"window.print()\"></div>

            <div class=\"panelKategorie\">
                <div class=\"question\" title=\"při najetí myší na požadované místo obdržíte nápovědu\"></div>
                ".$this->showKategorieInProdukt($produkt['id_kategorie'], " - ")."
            </div>
            <div class=\"produkt\">
                <div class=\"left\">
                    <div class=\"$disp\">
                        <div class=\"message\">$message</div>
                    </div>    
                    <div class=\"lupaPosII\" onmouseover=\"show('detail')\" onmouseout=\"hide('detail')\">
                        <div class=\"lupaBack\"></div>
                        <div class=\"lupaImg\"></div>
                    </div>  
                    <div id=\"detail\" class=\"zoom\" style=\"display: none;\">
                            ". $this->getImg($idProdukty, "Normal.jpg", 1, 1) ."
                            <div></div>
                    </div>
                    <div class=\"img\">                                      
                    ".$this->getImg($idProdukty, "Normal.jpg", 0, 1)."
                    </div>
                    <div class=\"hodnoceni\">
                        ".$this->showHodnoceni($produkt['hodnoceni'], $produkt['poc_hodnoceni'])."
                    </div>
                </div>
                <div class=\"right\">
                    <h1>".$produkt['nazev']."</h1>
                    <p>". $produkt['popis']."</p>
                    <h2>". $produkt['nazev_obl']."</h2>
                    <p>". $produkt['popis_obl']."</p>
                    <div class=\"produktInfo\">
                        <label>Materiál:</label><p>". $produkt['mater']."</p>
                        $gramaz
                        <label>Limitovaných:</label><p>". $produkt['limitovano']." ks</p>
                        <label>Prodaných:</label><p>". $produkt['poc_prodanych']." ks</p>
                        <div class=\"corrector\"></div>
                    </div>
                    <form action=\"". $_SERVER['REQUEST_URI'] ."\" method=\"post\">
                    <fieldset>
                        <div title=\"(šířka x výška) - rozměry se u jednotlivých výrobců liší\">
                            <label for=\"velikost\">Velikost</label>".$this->showVelikost($idProdukty)."
                        </div><br />
                        <label for=\"barva\">Barva</label>".$this->showBarva($idProdukty)."<br />
                        <label for=\"pocet\" title=\"Počet kusů, kolik chcete přidat do košíku.\">Počet</label>
                            <input class=\"w30\" type=\"text\" name=\"pocet\" id=\"pocet\" value=\"1\" maxlength=\"1\" title=\"Počet kusů, kolik chcete přidat do košíku.\" /><br />
                        <input class=\"doKosiku\" type=\"submit\" name=\"toBasket\" value=\"Přidat do košíku\" />
                    </fieldset>
                    </form>
                    <div class=\"cena\">
                        <p>".$produkt['cena'].",- Kč</p>
                    </div>
                </div>
            <div class=\"corrector\"></div>
            </div>
            
        ";
        return $result;
    }
    
    function showOtherImgNahledy($idProdukty){
     //   $det= ($detail==false) ? "AND detail = 0" : "AND detail = 1";
        $query= "SELECT id_obrazky, cesta, detail FROM obrazky WHERE id_produkty = $idProdukty AND hlavni = 0";
        $imgs= $this->Select($query);
        $result="";
        if(count($imgs)>0){
            $result= "<div class=\"nahledyVdetailu\">";
            foreach($imgs as $key => $value){
                $idObrazky= $value['id_obrazky'];
                $result.= "
                    <div class=\"nahled\">
                        <img src=\"/img/produkty/".$value['cesta']."Thumb.jpg\" alt=\"Náhled\"
                            onmouseover=\"show('img$idObrazky')\" onmouseout=\"hide('img$idObrazky')\" />
                    </div>
                    <div id=\"img$idObrazky\" class=\"zoom\" style=\"display: none;\">
                        <img src=\"/img/produkty/".$value['cesta']."Normal.jpg\" alt=\"Náhled\" />
                        <div></div>
                    </div>
                ";
            }
            $result.= "<div class=\"corrector\"></div></div>";    
        }
        return $result;
    }
        
    function showVyhledavani(){
        $result="
            <div class=\"lMenu\">
                <h1>Vyhledávání</h1>
                <div class=\"vyhledavani\">
                    <form action=\"index.php?menu=vyhledavani\" method=\"post\">
                        <fieldset>
                            <input class=\"vyhledavaniText\" type=\"text\" name=\"vyhledavani\" />
                            <input class=\"vyhledavaniSubmit\" type=\"submit\" name=\"odeslat\" value=\"Hledat\" />
                        </fieldset>
                    </form>
                </div>
            </div>
        ";
        return $result;
    }
  
    function hodnotUziv($idUziv, $idProdukty, $znamka){
        $query= "SELECT COUNT(znamka)as pocet FROM hod_pro WHERE id_uziv=$idUziv AND id_produkty=$idProdukty";
        $result= $this->Select($query);
        if($result[0]['pocet']==0){
            $values= array($idProdukty, $idUziv, $znamka);
            $this->Insert("hod_pro", "id_produkty, id_uziv, znamka", $values);
            return true;
        }else{
            return false;
        }
    }
    
    function hodnotHost($IP, $idProdukty, $znamka){
        $query= "SELECT COUNT(znamka)as pocet FROM hod_pro_host WHERE IP='$IP' AND id_produkty=$idProdukty";
        $result= $this->Select($query);
        if($result[0]['pocet']==0){
            $values= array($idProdukty, $IP, $znamka);
            $this->Insert("hod_pro_host", "id_produkty, IP, znamka", $values);
            return true;
        }else{
            return false;
        }
    }
    

}  
?>
