<?php
class TsiteMap extends TDBoperations{
    /**
    * vytvori strom odkazu vsech kategorie
    * 
    * @param mixed $id_kategorie - od ktere kategorie bude strom tvoren
    * @param mixed $selectId - oznaci vzbranou kategorie(class=menuSelected)
    * @param mixed $level
    * @param mixed $result
    */
    function recurseKategorie($table, $id_kategorie, $level=-1, $result=""){
        if($table == "kategorie") $menu= "obchod";
        if($table == "kategorie_navrhy") $menu= "navrhy";
        $sql= "SELECT id_kategorie, nazev, publikovano, seo 
                FROM $table 
                WHERE id_nad_kategorie=$id_kategorie
                AND publikovano = 1
                ORDER BY nazev";
        $queryResult= $this->Select($sql);
        $level++;   
        foreach($queryResult as $key => $value){
            $pocProduktu= $this->countRecords("produkty", "WHERE publikovano=1 and id_kategorie=".$value['id_kategorie']);
            $pocProduktu= ($pocProduktu==0) ? '' : "($pocProduktu)";
            $pocNadKategorii= count($queryResult);
            
            $result.= "
                <div style=\"margin-left: ". $level * 20 ."px;\">
                    <a href=\"/$menu/".$value['seo'].".htm\">".$value['nazev']."</a><span>$pocProduktu</span>
                </div>
            ";     
            if($pocNadKategorii > 0){
                $result= $this->recurseKategorie($table, $value['id_kategorie'], $level, $result);
            
            }
        }         
        return $result;
    }
        
    function recurseKategorieXML($table, $id_kategorie, $level=-1, $result=""){
        if($table == "kategorie") $menu= "obchod";
        if($table == "kategorie_navrhy") $menu= "navrhy";        
        $sql= "SELECT id_kategorie, nazev, publikovano, seo 
                FROM $table 
                WHERE id_nad_kategorie=$id_kategorie
                AND publikovano = 1
                ORDER BY nazev";
        $queryResult= $this->Select($sql);
        $level++;   
        foreach($queryResult as $key => $value){
            $pocProduktu= $this->countRecords("produkty", "WHERE publikovano=1 and id_kategorie=".$value['id_kategorie']);
            $pocProduktu= ($pocProduktu==0) ? '' : "($pocProduktu)";
            $pocNadKategorii= count($queryResult);
            
            $result.= "
                <url>
                    <loc>http://www.pro-poteseni.cz/$table/".$value['seo'].".htm</loc>
                    <changefreq>monthly</changefreq>
                    <priority>0.8</priority>
                </url>            
            ";     
            if($pocNadKategorii > 0){
                $result= $this->recurseKategorieXML($table, $value['id_kategorie'], $level, $result);
            
            }
        }         
        return $result;
    }        
    
    function generateGoogleSiteMap(){
        $date= date("Y-m-d");
        $xml_output  = "<?xml version=\"1.0\"?>\n"; 
        $xml_output.= "
            <urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">
                <url>
                    <loc>http://www.pro-poteseni.cz/</loc>
                    <lastmod>$date</lastmod>
                    <changefreq>monthly</changefreq>
                    <priority>0.1</priority>
                </url>
                <url>
                    <loc>http://www.pro-poteseni.cz/uvod.htm</loc>
                    <lastmod>$date</lastmod>
                    <changefreq>monthly</changefreq>
                    <priority>0.1</priority>
                </url>
                <url>
                    <loc>http://www.pro-poteseni.cz/aktuality.htm</loc>
                    <lastmod>$date</lastmod>
                    <changefreq>monthly</changefreq>
                    <priority>0.8</priority>
                </url>
                <url>
                    <loc>http://www.pro-poteseni.cz/o-nas.htm</loc>
                    <lastmod>$date</lastmod>
                    <changefreq>monthly</changefreq>
                    <priority>0.8</priority>
                </url>
                <url>
                    <loc>http://www.pro-poteseni.cz/obchodni-podminky.htm</loc>
                    <lastmod>$date</lastmod>
                    <changefreq>never</changefreq>
                    <priority>0.2</priority>
                </url>                                                                
                <url>
                    <loc>http://www.pro-poteseni.cz/obchod.htm</loc>
                    <lastmod>$date</lastmod>
                    <changefreq>never</changefreq>
                    <priority>0.8</priority>
                </url>
                <url>
                    <loc>http://www.pro-poteseni.cz/navrhy.htm</loc>
                    <lastmod>$date</lastmod>
                    <changefreq>never</changefreq>
                    <priority>0.7</priority>
                </url>         
                ". $this->recurseKategorieXML("kategorie", 1) ."                       
                ". $this->recurseKategorieXML("kategorie_navrhy", 1) ."                       
            </urlset> 
        ";
                
        $filename= "sitemap.xml";
        $file= fopen($filename, "w");
        fwrite($file, $xml_output);
        return $xml_output; 
        return $result;
    }
    
    function generProduktyXML($domena){
        $date= date("Y-m-d");
        $xml_output  = "<?xml version=\"1.0\" encoding=\"windows-1250\"?>\n"; 
        $xml_output.= "<SHOP>";
        
        $query= "
            SELECT produkty.nazev, popis, produkty.seo as p_seo, kategorie.seo as k_seo, cena, cesta
                FROM produkty, kategorie, obrazky   
                    WHERE   produkty.id_kategorie = kategorie.id_kategorie
                    AND     produkty.id_produkty = obrazky.id_produkty
                    AND     produkty.publikovano = 1
        ";
        $produkty= $this->Select($query);
        
        foreach($produkty as $key => $value){
            $xml_output.="
                <SHOPITEM>
                    <PRODUCT>". $value['nazev'] ."</PRODUCT>
                    <DESCRIPTION>". $value['popis'] ."</DESCRIPTION>
                    <URL>http://$domena/obchod/". $value['k_seo'] ."/". $value['p_seo'] .".htm</URL>
                    <IMGURL>http://$domena/img/produkty/". $value['cesta'] ."Normal.jpg</IMGURL>
                    <PRICE_VAT>". $value['cena'] ."</PRICE_VAT>
                </SHOPITEM>
            ";
        }
        
        $xml_output.= "</SHOP>";
        $filename= "produkty.xml";
        $file= fopen($filename, "w");
        fwrite($file, $xml_output);
    }
}
?>